DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Static Private Attributes | List of all members
DcmPersonName Class Reference

a class representing the DICOM value representation 'Person Name' (PN) More...

Inheritance diagram for DcmPersonName:

## Public Member Functions
| DcmPersonName (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmPersonName (const DcmPersonName &old)
| copy constructor
virtual | ~DcmPersonName ()
| destructor
DcmPersonName & | operator= (const DcmPersonName &obj)
| assignment operator
virtual DcmObject * | clone () const
| clone method
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying.
virtual DcmEVR | ident () const
| get element type identifier
virtual OFCondition | checkValue (const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM.
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a copy of a particular string component
OFCondition | getNameComponents (OFString &lastName, OFString &firstName, OFString &middleName, OFString &namePrefix, OFString &nameSuffix, const unsigned long pos=0, const unsigned int componentGroup=0)
| get name components from the element value.
OFCondition | getFormattedName (OFString &formattedName, const unsigned long pos=0, const unsigned int componentGroup=0)
| get current element value as a formatted/readable name.
OFCondition | putNameComponents (const OFString &lastName, const OFString &firstName, const OFString &middleName, const OFString &namePrefix, const OFString &nameSuffix)
| put element value from specified name components.
OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format
Public Member Functions inherited from DcmCharString
| DcmCharString (const DcmTag &tag, const Uint32 len)
| constructor.
| DcmCharString (const DcmCharString &old)
| copy constructor
virtual | ~DcmCharString ()
| destructor
DcmCharString & | operator= (const DcmCharString &obj)
| assignment operator
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored string value.
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this element contains non-ASCII characters.
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this element is affected by SpecificCharacterSet
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this element value from the currently selected source character set to the currently selected destination character set
virtual OFBool | matches (const OFString &key, const OFString &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching on a single pair of string values.
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching.
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching.
Public Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag)
| constructor.
| DcmByteString (const DcmByteString &old)
| copy constructor
virtual | ~DcmByteString ()
| destructor
DcmByteString & | operator= (const DcmByteString &obj)
| assignment operator
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type.
virtual OFCondition | clear ()
| clear the currently stored value
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element.
Uint32 | getRealLength ()
| get length of the stored value.
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| get DICOM length of the stored value.
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print element to a stream.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream as required for the creation of digital signatures
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get entire element value as a character string.
virtual OFCondition | getString (char *&stringVal)
| get a pointer to the current string value.
virtual OFCondition | getString (char *&stringVal, Uint32 &stringLen)
| get a pointer to the current string value.
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string.
virtual OFCondition | putOFStringAtPos (const OFString &stringVal, const unsigned long pos=0)
| set element value at specific VM position in the given character string.
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string.
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmElement (const DcmElement &old)
| copy constructor
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this.
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8.
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16.
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16.
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32.
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32.
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32.
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64.
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64.
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64.
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey.
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16.
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16.
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32.
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32.
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32.
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64.
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64.
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64.
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object).
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued).
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value.
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value.
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value.
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value.
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value.
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value.
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value.
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued).
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued).
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued).
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued).
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued).
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued).
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued).
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it.
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it.
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file.
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again.
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image.
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object.
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching.
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
virtual void | transferEnd (void)
| finalize the transfer state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
virtual DcmItem * | getParentItem ()
| get parent item of this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Static Public Member Functions
static OFCondition | getNameComponentsFromString (const OFString &dicomName, OFString &lastName, OFString &firstName, OFString &middleName, OFString &namePrefix, OFString &nameSuffix, const unsigned int componentGroup=0)
| get name components from specified DICOM person name.
static OFCondition | getComponentGroup (const OFString &allCmpGroups, const unsigned int groupNo, OFString &cmpGroup)
| get single component group from specified DICOM person name.
static OFCondition | getFormattedNameFromString (const OFString &dicomName, OFString &formattedName, const unsigned int componentGroup=0)
| get specified DICOM person name as a formatted/readable name.
static OFCondition | getFormattedNameFromComponents (const OFString &lastName, const OFString &firstName, const OFString &middleName, const OFString &namePrefix, const OFString &nameSuffix, OFString &formattedName)
| get formatted/readable name from specified name components.
static OFCondition | getStringFromNameComponents (const OFString &lastName, const OFString &firstName, const OFString &middleName, const OFString &namePrefix, const OFString &nameSuffix, OFString &dicomName)
| get DICOM Person Name (PN) from specified name components.
static OFCondition | checkStringValue (const OFString &value, const OFString &vm="1-n", const OFString &charset="")
| check whether given string value conforms to the VR "PN" (Person Name) and to the specified VM.
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR)
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR)
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM)
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string.
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM)

## Static Private Attributes
static const char *const | componentGroupNames [3]
| an array containing the component group names, for XML and JSON output.

## Additional Inherited Members
Protected Types inherited from DcmByteString
enum | E_StringMode { DCM_MachineString , DCM_DicomString , DCM_UnknownString }
| internal type used to specify the current string representation More...
Protected Member Functions inherited from DcmCharString
OFCondition | getSpecificCharacterSet (OFString &charset)
| get value of the SpecificCharacterSet element of the surrounding dataset/item
virtual const OFString & | getDelimiterChars () const
| get delimiter characters specifying when to switch back to the default character set (in case code extension techniques like ISO 2022 are used).
Protected Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag, const Uint32 len)
| constructor.
virtual Uint8 * | newValueField ()
| create a new value field (string buffer) of the previously defined size (member variable 'Length').
virtual void | postLoadValue ()
| method is called after the element value has been loaded.
E_StringMode | getStringMode () const
| get current representation of the string value
virtual OFCondition | makeMachineByteString (const Uint32 length=0)
| convert currently stored string value to internal representation.
OFCondition | makeDicomByteString ()
| convert currently stored string value to DICOM representation.
OFCondition | getStringValue (OFString &stringVal)
| get a copy of the current string value.
Uint32 | getMaxLength () const
| get the maximum number of characters for each string component
char | getPaddingChar () const
| get the end-of-string padding character
void | setPaddingChar (char c)
| set the end-of-string padding character
void | setMaxLength (Uint32 val)
| set the maximum number of characters for each string component
void | setNonSignificantChars (const OFString &characters)
| set non-significant characters used to determine whether the value is empty
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value.
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value.
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size.
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this.
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field
Static Protected Member Functions inherited from DcmByteString
static OFBool | containsExtendedCharacters (const char *stringVal, const size_t stringLen)
| check if a given character string contains non-ASCII characters.
static OFCondition | checkStringValue (const OFString &value, const OFString &vm, const OFString &vr, const int vrID, const size_t maxLen=0, const OFString &charset="")
| check whether given string value conforms to a certain VR and VM.
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM value representation 'Person Name' (PN)

## Constructor & Destructor Documentation

## ◆ DcmPersonName() [1/2]

DcmPersonName::DcmPersonName | ( | const DcmTag & | tag,
|  | const Uint32 | len = 0 )

constructor.

Create new element from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

Referenced by DcmPersonName(), clone(), and operator=().

## ◆ DcmPersonName() [2/2]

DcmPersonName::DcmPersonName | ( | const DcmPersonName & | old | ) |

copy constructor

Parameters

  old | element to be copied

References DcmPersonName().

## Member Function Documentation

## ◆ checkStringValue()

static OFCondition DcmPersonName::checkStringValue | ( | const OFString & | value,
|  | const OFString & | vm = "1-n",
|  | const OFString & | charset = "" )
| static

check whether given string value conforms to the VR "PN" (Person Name) and to the specified VM.

Parameters

  value | string value to be checked (possibly multi-valued)
  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  charset | character set (according to the value of the SpecificCharacterSet element) to be used for checking the string value. The default is ASCII (7-bit). Currently, the VR checker only supports ASCII (ISO_IR 6) and Latin-1 (ISO_IR 100). All other values disable the check of the value representation, e.g. "UNKNOWN".

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

## ◆ checkValue()

virtual OFCondition DcmPersonName::checkValue | ( | const OFString & | vm = "1-n",
|  | const OFBool | oldFormat = OFFalse )
| virtual

check whether stored value conforms to the VR and to the specified VM.

Currently, the VR checker only supports ASCII (ISO_IR 6) and Latin-1 (ISO_IR 100). All other specific character sets disable the check of the value representation.

Parameters

  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | parameter not used for this VR (only for DA, TM)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

Reimplemented from DcmElement.

## ◆ clone()

virtual DcmObject * DcmPersonName::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmCharString.

References DcmPersonName().

## ◆ copyFrom()

virtual OFCondition DcmPersonName::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmCharString.

## ◆ getComponentGroup()

static OFCondition DcmPersonName::getComponentGroup | ( | const OFString & | allCmpGroups,
|  | const unsigned int | groupNo,
|  | OFString & | cmpGroup )
| static

get single component group from specified DICOM person name.

The DICOM PN consists of up to three component groups separated by a "=". The supported format is "[CG0[=CG1[=CG2]]]" where the brackets enclose optional parts and CG0 is an alphabetic representation, CG1 an ideographic representation, and CG2 a phonetic representation of the name. Each component group might be empty. The returned component group will contain component delimiters ("^") as they are stored within the very component group, i.e. superfluous component delimiters are not removed.

Parameters

  allCmpGroups | string value in DICOM PN format to component group from
  groupNo | index of the component group (0..2) to be extracted
  cmpGroup | reference to string variable where selected component group shall be stored

Returns
  EC_Normal upon success, an error code otherwise. Especially, if a component group exists (always for group 0, for group 1 and 2 depending on whether corresponding "=" is present) and is empty, EC_Normal is returned.

## ◆ getFormattedName()

OFCondition DcmPersonName::getFormattedName | ( | OFString & | formattedName,
|  | const unsigned long | pos = 0,
|  | const unsigned int | componentGroup = 0 )

get current element value as a formatted/readable name.

The current element value is expected to be in DICOM PN format as described above. The output format is "[namePrefix][ firstName][ middleName][ lastName][, nameSuffix]"; the delimiters (" " and ", ") are only inserted if required. If this function fails the result variable 'formattedName' is cleared automatically.

Parameters

  formattedName | reference to string variable where the result is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  componentGroup | index of the component group (0..2) to be used, see above

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getFormattedNameFromComponents()

static OFCondition DcmPersonName::getFormattedNameFromComponents | ( | const OFString & | lastName,
|  | const OFString & | firstName,
|  | const OFString & | middleName,
|  | const OFString & | namePrefix,
|  | const OFString & | nameSuffix,
|  | OFString & | formattedName )
| static

get formatted/readable name from specified name components.

The output format is "[namePrefix][ firstName][ middleName][ lastName][, nameSuffix]"; the delimiters (" " and ", ") are only inserted if required. If this function fails the result variable 'formattedName' is cleared automatically.

Parameters

  lastName | reference to string variable where the "last name" is stored
  firstName | reference to string variable where the "first name" is stored
  middleName | reference to string variable where the "middle name" is stored
  namePrefix | reference to string variable where the "name prefix" is stored
  nameSuffix | reference to string variable where the "name suffix" is stored
  formattedName | reference to string variable where the result is stored

Returns
  always returns EC_Normal

## ◆ getFormattedNameFromString()

static OFCondition DcmPersonName::getFormattedNameFromString | ( | const OFString & | dicomName,
|  | OFString & | formattedName,
|  | const unsigned int | componentGroup = 0 )
| static

get specified DICOM person name as a formatted/readable name.

The specified 'dicomName' is expected to be in DICOM PN format as described above. The output format is "[namePrefix][ firstName][ middleName][ lastName][, nameSuffix]"; the delimiters (" " and ", ") are only inserted if required. If this function fails the result variable 'formattedName' is cleared automatically.

Parameters

  dicomName | string value in DICOM PN format to be converted to readable format
  formattedName | reference to string variable where the result is stored
  componentGroup | index of the component group (0..2) to be used, see above

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getNameComponents()

OFCondition DcmPersonName::getNameComponents | ( | OFString & | lastName,
|  | OFString & | firstName,
|  | OFString & | middleName,
|  | OFString & | namePrefix,
|  | OFString & | nameSuffix,
|  | const unsigned long | pos = 0,
|  | const unsigned int | componentGroup = 0 )

get name components from the element value.

The DICOM PN consists of up to three component groups separated by a "=". The supported format is "[CG0[=CG1[=CG2]]]" where the brackets enclose optional parts and CG0 is an alphabetic representation, CG1 an ideographic representation, and CG2 a phonetic representation of the name. Each component group may consist of up to five components separated by a "^". The format is "[lastName[^firstName[^middleName[^namePrefix[^nameSuffix]]]]"; each component group and each component might be empty. If this function fails the result variables are cleared automatically. If the format is valid but does not comply with the above described scheme ("=" and "^") the full person name is returned in the 'lastName' variable.

Parameters

  lastName | reference to string variable where the "last name" is stored
  firstName | reference to string variable where the "first name" is stored
  middleName | reference to string variable where the "middle name" is stored
  namePrefix | reference to string variable where the "name prefix" is stored
  nameSuffix | reference to string variable where the "name suffix" is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  componentGroup | index of the component group (0..2) to be used, see above

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getNameComponentsFromString()

static OFCondition DcmPersonName::getNameComponentsFromString | ( | const OFString & | dicomName,
|  | OFString & | lastName,
|  | OFString & | firstName,
|  | OFString & | middleName,
|  | OFString & | namePrefix,
|  | OFString & | nameSuffix,
|  | const unsigned int | componentGroup = 0 )
| static

get name components from specified DICOM person name.

The DICOM PN consists of up to three component groups separated by a "=". The supported format is "[CG0[=CG1[=CG2]]]" where the brackets enclose optional parts and CG0 is an alphabetic representation, CG1 an ideographic representation, and CG2 a phonetic representation of the name. Each component group may consist of up to five components separated by a "^". The format is "[lastName[^firstName[^middleName[^namePrefix[^nameSuffix]]]]"; each component group and each component might be empty. If this function fails the result variables are cleared automatically. If the format is valid but does not comply with the above described scheme ("=" and "^") the full person name is returned in the 'lastName' variable.

Parameters

  dicomName | string value in DICOM PN format to be split into components
  lastName | reference to string variable where the "last name" is stored
  firstName | reference to string variable where the "first name" is stored
  middleName | reference to string variable where the "middle name" is stored
  namePrefix | reference to string variable where the "name prefix" is stored
  nameSuffix | reference to string variable where the "name suffix" is stored
  componentGroup | index of the component group (0..2) to be used, see above

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFString()

virtual OFCondition DcmPersonName::getOFString | ( | OFString & | stringVal,
|  | const unsigned long | pos,
|  | OFBool | normalize = OFTrue )
| virtual

get a copy of a particular string component

Parameters

  stringVal | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | delete leading and trailing spaces if OFTrue

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmByteString.

## ◆ getStringFromNameComponents()

static OFCondition DcmPersonName::getStringFromNameComponents | ( | const OFString & | lastName,
|  | const OFString & | firstName,
|  | const OFString & | middleName,
|  | const OFString & | namePrefix,
|  | const OFString & | nameSuffix,
|  | OFString & | dicomName )
| static

get DICOM Person Name (PN) from specified name components.

The output format is "[lastName[^firstName[^middleName[^namePrefix[^nameSuffix]]]]]". Component groups are not (yet) supported. If this function fails the result variable 'dicomName' is cleared automatically.

Parameters

  lastName | reference to string variable where the "last name" is stored
  firstName | reference to string variable where the "first name" is stored
  middleName | reference to string variable where the "middle name" is stored
  namePrefix | reference to string variable where the "name prefix" is stored
  nameSuffix | reference to string variable where the "name suffix" is stored
  dicomName | reference to string variable where the result is stored

Returns
  always returns EC_Normal

## ◆ ident()

virtual DcmEVR DcmPersonName::ident | ( |  | ) | const
| virtual

get element type identifier

Returns
  type identifier of this class (EVR_PN)

Reimplemented from DcmByteString.

## ◆ operator=()

DcmPersonName & DcmPersonName::operator= | ( | const DcmPersonName & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

References DcmPersonName().

## ◆ putNameComponents()

OFCondition DcmPersonName::putNameComponents | ( | const OFString & | lastName,
|  | const OFString & | firstName,
|  | const OFString & | middleName,
|  | const OFString & | namePrefix,
|  | const OFString & | nameSuffix )

put element value from specified name components.

The stored format is "[lastName[^firstName[^middleName[^namePrefix[^nameSuffix]]]]]", i.e. a DICOM Person Name (PN). Component groups are not (yet) supported. If this function fails the currently stored value is not modified.

Parameters

  lastName | reference to string variable where the "last name" is stored
  firstName | reference to string variable where the "first name" is stored
  middleName | reference to string variable where the "middle name" is stored
  namePrefix | reference to string variable where the "name prefix" is stored
  nameSuffix | reference to string variable where the "name suffix" is stored

Returns
  EC_Normal upon success, an error code otherwise

## ◆ writeJson()

virtual OFCondition DcmPersonName::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format )
| virtual

write object in JSON format

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmCharString.

## ◆ writeXML()

OFCondition DcmPersonName::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0 )
| virtual

write object in XML format

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcvrpn.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2